########################################
Args <- commandArgs(TRUE);

max_sample    <- as.integer(Args[8]); # sample size (maximum number of samples)
n_sample_job  <- as.integer(Args[9]);  # number of samples per job
n_cores       <- as.integer(Args[10]);    # number of cores of 2GB needed to fit the number of sample specified in n_diag_batch 
n_parallel_proc    <- as.integer(Args[11]);    # number of jobs you want to stack in a single shell script, number of shell scripts will be n_jobs / exe_per_job
tempdir = Args[6];


diag_program <- Args[1]; #"../bin/calc_PCAinput_diag.exe"  # path modified by chen
rect_program <- Args[2]; #"../bin/calc_PCAinput_rect.exe" # path modified by chen
covdir <- Args[3];
samplefile <- Args[4];
desdir <- Args[5];
outputdir <- Args[7];
chr_begin  <- Args[12];
chr_end  <- Args[13];


diag_program = paste(diag_program, covdir, samplefile, desdir, outputdir, chr_begin, chr_end);
rect_program = paste(rect_program, covdir, samplefile, desdir, outputdir, chr_begin, chr_end);

######################

n_total <- trunc( max_sample / n_sample_job) * n_sample_job
if ( n_total < max_sample ) n_total <-  n_total + n_sample_job

n_diag     <- n_total / n_sample_job
n_diag_arg <- matrix(NA,n_diag,2)
k <- 1
for (i in 1:n_diag) {
    n_diag_arg[i,1] <- k
    n_diag_arg[i,2] <- k + n_sample_job-1
    k <- k + n_sample_job
}

n_diag_arg[ n_diag_arg[,1] > max_sample, 1] <- max_sample
n_diag_arg[ n_diag_arg[,2] > max_sample, 2] <- max_sample

n_rect <- 0
if(n_diag>=2){ 	# ++ by chen
	if(max_sample > n_sample_job*(n_diag-0.5) || max_sample == n_sample_job*n_diag ) {
		n_rect <- n_diag*(n_diag-1);
	} else {
		n_rect <- (n_diag-1)^2;
	}
	#print(n_rect)
	n_rect_arg <- matrix(NA, n_diag*(n_diag-1), 4)
	k <- n_sample_job + 1
	row <- 1
	for (i in 2:n_diag) {
	   start <- 1
	   for (j in 1:(i-1) ) {
	       n_rect_arg[row,1] <- k
	       n_rect_arg[row,2] <- k + n_sample_job/ 2 - 1
	       n_rect_arg[row,3] <- start
	       n_rect_arg[row,4] <- start + n_sample_job - 1
	       row <- row + 1

	       n_rect_arg[row,1] <- k + n_sample_job/ 2
	       n_rect_arg[row,2] <- k + n_sample_job- 1
	       n_rect_arg[row,3] <- start
	       n_rect_arg[row,4] <- start + n_sample_job - 1
	       row <- row + 1
	       
	       start <- start + n_sample_job
	   }
	   k <- k + n_sample_job
	}


	sel <- !(n_rect_arg[,1] > max_sample) & !(n_rect_arg[,3] > max_sample)
	n_rect_arg <- n_rect_arg[sel, ] 


	n_rect_arg[ n_rect_arg[,1] > max_sample, 1] <- max_sample
	n_rect_arg[ n_rect_arg[,2] > max_sample, 2] <- max_sample
	n_rect_arg[ n_rect_arg[,3] > max_sample, 3] <- max_sample
	n_rect_arg[ n_rect_arg[,4] > max_sample, 4] <- max_sample

	n_jobs      <- length(n_diag_arg[,1]) + length(n_rect_arg[,1])
	# verify the calculation
	if(n_rect != length(n_rect_arg[,1])) {
		print("Error: n_rect != length(n_rect_arg[,1])");
		q(save="no");
	}
} else {  # ++ by chen

	n_jobs <- length(n_diag_arg[,1])  # ++ by chen
	
}         # ++ by chen



###### old code ###########################################################

#exe_per_job <- rep(trunc(n_jobs/n_parallel_proc),n_parallel_proc )
#n_jobs_left <- n_jobs  - sum(exe_per_job)
#if (n_jobs_left > 0) exe_per_job[(n_parallel_proc-n_jobs_left+1):n_parallel_proc] <- exe_per_job[(n_parallel_proc-n_jobs_left+1):n_parallel_proc]+1
#
#
#max_diag   <- length(n_diag_arg[,1])
#
#if(n_diag>=2) {
#max_rect   <- length(n_rect_arg[,1])
#} else {
#max_rect = 0;
#}
#
#count_diag <- 1 
#count_rect <- 1
#for (i in 1:n_parallel_proc) {
#  
#   count_exe <- 0
#   outfil    <- paste(tempdir,"pca_compute_XXT_", "chr", chr_begin, "-", chr_end, "_", i, ".bat",sep="") # ".sh" -> ".bat"
#   file.create(outfil);
#
#   while ( count_exe < exe_per_job[i] ) {
#      
#      if (count_diag <= max_diag) {
# 
#           next_line  <- paste (diag_program," ",n_diag_arg[count_diag,1]," ",n_diag_arg[count_diag,2],"\n",sep="")
#
#           next_line  <- paste (diag_program,n_diag_arg[count_diag,1],n_diag_arg[count_diag,2],"\n",sep=" ")
#
#           cat(next_line              ,file=outfil,append = T)  
#
#           count_exe  <- count_exe + 1 
#           count_diag <- count_diag + 1
# 
#         } else if (count_rect <= max_rect) {
#
#           next_line  <- paste (rect_program," ",n_rect_arg[count_rect,1]," ",n_rect_arg[count_rect,2]," ",n_rect_arg[count_rect,3]," ",n_rect_arg[count_rect,4],"\n",sep="")
#   
#           next_line  <- paste (rect_program,n_rect_arg[count_rect,1],n_rect_arg[count_rect,2],n_rect_arg[count_rect,3],n_rect_arg[count_rect,4],"\n",sep=" ")
# 
#
#           cat(next_line,file=outfil,append = T) 
# 
#           count_exe  <- count_exe + 1 
#           count_rect <- count_rect + 1
#        }
#   } # end while
#} # end for 

###########################################################################

##################### new code ############################################
max_diag   <- length(n_diag_arg[,1])
if(n_diag>=2) {
    max_rect   <- length(n_rect_arg[,1])
} else {
    max_rect = 0;
}

n_jobs = max_diag + max_rect;
#cat("Task distribution in scripts\n")
#cat("The number of samples in each diagonal chunck is ", n_sample_job, "\n");
#cat("The total number of partitioned diagonal chunks of XXT from chr", chr_begin, " to chr", chr_end, " is ", max_diag, "\n");
#cat("The total number of partitioned rectangual chunks of XXT from chr", chr_begin, " to chr", chr_end, " is ", max_rect, "\n");
#cat("These will be computed in ", n_parallel_proc, " scripts \n");

residual = n_jobs %% n_parallel_proc;
multiplier = floor(n_jobs/n_parallel_proc);
assignment = matrix(multiplier, n_parallel_proc, 1);
assignment[1:residual] = assignment[1:residual] + 1;
#cat("task assignment:\n");
#print(assignment, row.names=F, col.names=paste("scripts", 1:n_parallel_proc));

############## write the command into scripts #########
count_diag <- 1 
count_rect <- 1

# create scripts
outfil = list();
for (i in 1:n_parallel_proc) {
	outfil[[i]]    <- paste(tempdir,"pca_compute_XXT_", i, ".bat",sep="") # ".sh" -> ".bat"
   	file.create(outfil[[i]]);
}

out_diag = 0;
out_rect = 0;
file_i = 0;  # coded as 0 ... (n_parallel_proc-1); +1 when to access the filename
while( out_diag < max_diag || out_rect < max_rect ) {	
	filename = outfil[[file_i+1]];
	if( out_diag < max_diag ) {
		# output diag
		out_diag  <- out_diag + 1
		next_line  <- paste (diag_program,n_diag_arg[out_diag,1],n_diag_arg[out_diag,2],"\n",sep=" ");
		cat(next_line,file=filename,append = T)  
           	 
	} else if ( out_rect < max_rect ){
		# output rect
		out_rect  <- out_rect + 1
		next_line  <- paste (rect_program,n_rect_arg[out_rect,1],n_rect_arg[out_rect,2],n_rect_arg[out_rect,3],n_rect_arg[out_rect,4],"\n",sep=" ") 
		cat(next_line,file=filename,append = T) 	 
	}
	file_i = (file_i + 1) %% n_parallel_proc;
}

