# output PCs based on the matrix XXT

rm(list=ls())
source("pcaFromXXT.R")
source("reCenterKMatrix.R")

# set up input paramters
Args <- commandArgs(TRUE);
filenameXXT = Args[1];
outputPCFile = Args[2];
outputVarianceFile = Args[3];
outputUmatrixFile = Args[4];

XXT = read.csv(filenameXXT, check.names=F);
XXT = as.matrix(XXT);

# recenter
XXT = reCenterKMatrix(XXT);

rs = pcaFromXXT(XXT);
N = dim(XXT)[1];

variances = rs[[1]];
PCs = rs[[2]];
Umatrix = rs[[3]];

numberOfPCs = dim(PCs)[2]

outputPCs = PCs[,1:numberOfPCs];

# rowname
subjectNames = matrix("", 1,N);
rawNames = colnames(XXT);
subjectNames = rawNames;

rownames(outputPCs) =  subjectNames;
colnames(outputPCs) = paste("PC", 1:numberOfPCs, sep="");
write.csv(outputPCs, file=outputPCFile);

# output eigen values
dim(variances) = c(length(variances),1)
colnames(variances) = "Eigenvalues"
write.csv(variances, file=outputVarianceFile, row.names=FALSE)

# output U matrix
colnames(Umatrix) = paste("u", 1:dim(Umatrix)[2], sep="")
rownames(Umatrix) =  subjectNames;
write.csv(Umatrix, file=outputUmatrixFile);
