# prepare_pheno.R

Args <- commandArgs(TRUE);

samplefile_orig = Args[1]
extra_covariates_file = Args[2];
included_covariates_indice_file = Args[3];
association_workdir = Args[4];
pheno_file = Args[5];

phenoData = read.csv(samplefile_orig, header=T);
extraCovariatesData = read.csv(extra_covariates_file, header=T);
included_covariates_indice = as.matrix(read.csv(included_covariates_indice_file, header=T));
phenoData = cbind(phenoData, extraCovariatesData[, included_covariates_indice+1]); 
# remove the variable of 0 variance
covariates = phenoData[,3:dim(phenoData)[2]];
vars  = apply(covariates, 2, var);
#print(vars)
ind0 = which(vars > 1e-13);
#print(ind0)
phenoData = phenoData[,c(1,2,2+ind0)];
write.csv(phenoData, file=pheno_file, quote=F, row.names=F)