qsubCmdLinesInFile = function(cmdFile, eachLine=T, jobName, depName, timeGap, tempFile, logPath, ncores, mem, oeNumber=0){
	
	file.create(tempFile);
	cmdLines = readLines(cmdFile);
	outputName = basename(cmdFile);
	outputName = substr(outputName, 1, nchar(outputName)-4);
	if(mem>0){
		mem_option = paste(" -l mem_free=", mem, "G", sep="");
	} else {
		mem_option = ""
	}
	if(eachLine){	
		for (i in 1:length(cmdLines)){
			cmd = cmdLines[i];
			if(length(cmd)>0){
				cat("#! /bin/bash\n", file=tempFile);
				cat("#$ -S /bin/bash\n",file=tempFile, append=T);
				cat("#$ -cwd\n", file=tempFile, append=T);
				if(ncores>1){
					cat(paste("#$ -pe smp", ncores, "\n"), file=tempFile, append=T);
				}
				cat("hostname\n", file=tempFile, append=T);
				cat("ulimit -n\n", file=tempFile, append=T);
				cat(cmd, file=tempFile, append=T);
				if(length(cmdLines)>1){
					outFile = paste(logPath, "/", outputName, "_", i, ".o", sep="");
					errorFile = paste(logPath, "/", outputName, "_", i, ".e", sep="");
				} else {
					outFile = paste(logPath, "/", outputName, ".o", sep="");
					errorFile = paste(logPath, "/", outputName, ".e", sep="");
				}

				
				file.create(outFile);
				file.create(errorFile);
				if(nchar(depName)>0){
					qsubCmd = paste("qsub", mem_option, "-hold_jid", depName, "-N", jobName, "-o", outFile, "-e", errorFile, tempFile);
				} else {
					qsubCmd = paste("qsub", mem_option, "-N", jobName, "-o", outFile, "-e", errorFile, tempFile);
				}
				#print(qsubCmd);
				system(qsubCmd);
				Sys.sleep(timeGap);
			}
		}
	} else {
		if(length(cmdLines)>0){	
				cat("#! /bin/bash\n", file=tempFile);
				cat("#$ -S /bin/bash\n",file=tempFile, append=T);
				cat("#$ -cwd\n", file=tempFile, append=T);
				cat("hostname\n", file=tempFile, append=T);
				if(ncores>1){
					cat(paste("#$ -pe smp", ncores, "\n"), file=tempFile, append=T);
				}
				cat("ulimit -n\n", file=tempFile, append=T);
				cat(cmdLines, file=tempFile, sep="\n", append=T);
				outFile = paste(logPath, "/", outputName, ".o", sep="");
				errorFile = paste(logPath, "/", outputName, ".e", sep="");
				file.create(outFile);
				file.create(errorFile);
				if(nchar(depName)>0){
					qsubCmd = paste("qsub", mem_option, "-hold_jid", depName, "-N", jobName, "-o", outFile, "-e", errorFile, tempFile);
				} else {
					qsubCmd = paste("qsub", mem_option, "-N", jobName, "-o", outFile, "-e", errorFile, tempFile);
				}
				#print(qsubCmd);
				system(qsubCmd);
				Sys.sleep(timeGap);
		}
	}
}