#include <cstdlib>

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include <vector>
#include <cmath>
#include <ctime>
#include <stdio.h>

#include "constants.h"

using namespace std;

typedef vector<vector<double> > matrix_t;
matrix_t cpg_data_row, cpg_data_col;
void sizeMatrix(matrix_t &, int,int);

string samplenames[max_sample];
double mean_vector[max_coord_total], sd_vector[max_coord_total];

int coordlen, n_sample, start_coord = 0, tot_coord = 0, i_coord, n_rows = 0, n_cols = 0, i_sample=0;

void read_sample(const char * filename);
void read_cpg_data_row(const char * filename);
void read_cpg_data_col(const char * filename);
void read_mean_sd(const char * filename);

int main(int argc, char *argv[])
 {
   int row_begin = atoi(argv[7]);
   int row_end = atoi(argv[8]);
   int col_begin = atoi(argv[9]);
   int col_end = atoi(argv[10]);
   int start_chrom = atoi(argv[5]);
   int end_chrom = atoi(argv[6]);


   int i, j, i_chrom, row_nr, col_nr, sample_nr;
   matrix_t results, results_st;

   string filna;
   stringstream ss;
   const char *ptemp;


   string tempdir   = argv[4];

   string covdir    = argv[1];
   string desdir    = argv[3];

   string samplefil = argv[2];

   const clock_t begin_time = clock();
   ifstream desfil;
   for(i_chrom=start_chrom;i_chrom<=end_chrom;i_chrom++) {
      ss << desdir << "des_chr" << i_chrom << ".csv";
      filna.clear(); filna = ss.str(); ss.str(string()); ptemp= filna.c_str(); (desfil).open(ptemp);
      read_mean_sd(ptemp);  }

   tot_coord = start_coord;
   cout << "total # of sites " << tot_coord <<    "\n";


//@@@ read sample names
   ss << samplefil;
   filna = ss.str(); ss.str(string()); ptemp= filna.c_str();
   read_sample(ptemp);
   cout << "# samples " << n_sample << "\n";


    ifstream infils;
//@@@ read cpg data for row elements
    n_rows = row_end - row_begin + 1;
    sizeMatrix(cpg_data_row, tot_coord + 10,n_rows);
    i_sample = 0; //
    for(row_nr=row_begin;row_nr<=row_end;row_nr++) { // read data from all samples in range

     sample_nr = row_nr - 1; // adjust for fact C++ starts at 0
     start_coord = 0;

    for(i_chrom=start_chrom;i_chrom<=end_chrom;i_chrom++) {
         ss << covdir << "chr" << i_chrom << "/" << samplenames[sample_nr] << ".csv" ;
         filna.clear(); filna = ss.str(); ss.str(string());ptemp= filna.c_str(); (infils).open(ptemp);
         if (!(infils).is_open()) {cout << "file named " << ptemp << "  is not open \n"; exit(-1);}
         read_cpg_data_row(ptemp);
  		 cout << "file named " << ptemp << "  is read  \n";
  		 cout.flush();
         (infils).close();
    }  // end i_chrom

   i_sample++;
   }  // end for   (row_nr

//@@@ read cpg data for col elements
    n_cols = col_end - col_begin + 1;
    sizeMatrix(cpg_data_col, tot_coord + 10,n_cols);
    i_sample = 0; //
    for(col_nr=col_begin;col_nr<=col_end;col_nr++) { // read data from all samples in range

     sample_nr = col_nr - 1; // adjust for fact C++ starts at 0
     start_coord = 0;

    for(i_chrom=start_chrom;i_chrom<=end_chrom;i_chrom++) {
         ss << covdir << "chr" << i_chrom << "/" << samplenames[sample_nr] << ".csv" ;
         filna.clear(); filna = ss.str(); ss.str(string());ptemp= filna.c_str(); (infils).open(ptemp);
         if (!(infils).is_open()) cout << "file named " << ptemp << "  is not open \n";

         read_cpg_data_col(ptemp);
         (infils).close(); }  // end i_chrom

   i_sample++;
   }  // end for   (col_nr

   cout << "Seconds used since reading methylation files: " << float( clock () - begin_time ) /  CLOCKS_PER_SEC << endl;
   cout << "Finish reading files. Start the computing of inner product matirx..." << endl;
   cout.flush();
   sizeMatrix(results, n_rows,n_cols);
   sizeMatrix(results_st, n_rows,n_cols);

   double dif_row[n_rows], dif_row_st[n_rows];
   double dif_col[n_cols], dif_col_st[n_cols];

   for(i=0;i<n_rows;i++) for(j=0;j<n_cols;j++) {results[i][j]=0;results_st[i][j]=0;}

   for(i_coord=0;i_coord<tot_coord;i_coord++) {

      for(i=0;i<n_rows;i++) {                             // calculate the deviation scores
          dif_row[i]    = cpg_data_row[i_coord][i] - mean_vector[i_coord];
          if (sd_vector[i_coord] > sd_threshold) {
			  dif_row_st[i] = dif_row[i] / sd_vector[i_coord];
		  } else {
			  dif_row_st[i] = 0;
			  if(i==0) {
			  	cout << " Standardard deviation of site " << i_coord << " is (very close to) zero: Loadings set to zero\n";
			  }
		  }
      }


     for(i=0;i<n_cols;i++) {                             // calculate the deviation scores
          dif_col[i]    = cpg_data_col[i_coord][i] - mean_vector[i_coord];
          if (sd_vector[i_coord] > sd_threshold) {
			  dif_col_st[i] = dif_col[i] / sd_vector[i_coord];
		  } else {
			  dif_col_st[i] = 0;
			  if(i==0) {
			  	cout << " Standardard deviation of site " << i_coord << " is (very close to) zero: Loadings set to zero\n";
			  }
		  }
      }


      for(i=0;i<n_rows;i++)                               // calcuate the inner products
        for(j=0;j<n_cols;j++) {
           results[i][j] = results[i][j]  +  dif_row[i]*dif_col[j];
           results_st[i][j] = results_st[i][j]  +  dif_row_st[i]*dif_col_st[j];
        }

  } // end for(i_coord=0;_coord<tot_coord;_coord++)

    cout << "Seconds used since reading methylation files: " << float( clock () - begin_time ) /  CLOCKS_PER_SEC << endl;
    cout  << " done \n";

   ss << tempdir << "rect_" << row_begin << "." << row_end << "_" << col_begin << "." << col_end << "_.csv" ;
   filna = ss.str(); ss.str(string()); ptemp= filna.c_str(); ofstream outfile; outfile.open(ptemp);
   outfile.setf(ios::scientific);
   outfile.precision(15); // modified from 7 to 15 by chen
   cout << "outfile named " << ptemp << "  is written \n";
   j = 0;
   for(i=0;i<n_rows;i++)  {
       outfile << results[i][0];
       for(j=1;j<n_cols;j++) outfile << "," << results[i][j];
       outfile << "\n"; }
   outfile.close();

   ss << tempdir << "rectst_" << row_begin << "." << row_end << "_" << col_begin << "." << col_end << "_.csv" ;
   filna = ss.str(); ss.str(string()); ptemp= filna.c_str(); outfile.open(ptemp);
   outfile.setf(ios::scientific);
   outfile.precision(15);
   cout << "outfile named " << ptemp << "  is written \n";
   for(i=0;i<n_rows;i++)  {
       outfile << results_st[i][0];
       for(j=1;j<n_cols;j++) outfile << "," << results_st[i][j];
       outfile << "\n"; }
   outfile.close();



    return EXIT_SUCCESS;
}



//-------------------------------------------------


void read_cpg_data_row(const char * filename) {

    string STRING, subst;
	ifstream infile;
	size_t pos, oldpos;

	infile.open (filename);

	getline(infile,STRING); // Skipping the header

   while(!infile.eof()) { // To get you all the lines.

        getline(infile,STRING);
        oldpos = STRING.find(',');
        pos=STRING.find(',',oldpos+1);
        subst = STRING.substr(oldpos+1,pos-oldpos-1);
        cpg_data_row[start_coord][i_sample] = atof(subst.c_str()) ;
        start_coord++;
    }

    if (STRING=="") start_coord = start_coord-1;
    infile.close();

}



void read_cpg_data_col(const char * filename) {

    string STRING, subst;
	ifstream infile;
	size_t pos, oldpos;

	infile.open (filename);

	getline(infile,STRING); // Skipping the header

   while(!infile.eof()) { // To get you all the lines.

        getline(infile,STRING);
        oldpos = STRING.find(',');
        pos=STRING.find(',',oldpos+1);
        subst = STRING.substr(oldpos+1,pos-oldpos-1);
        cpg_data_col[start_coord][i_sample] = atof(subst.c_str()) ;
        start_coord++;
    }

    if (STRING=="") start_coord = start_coord-1;
    infile.close();

}


void read_sample(const char * filename) {

    string STRING;
	ifstream infile;
	int i=0;

	infile.open (filename);

    if (!(infile).is_open()) { cout << "file named " << filename << "  is not open \n"; exit(-1);}
      else cout << "sample file " << filename << "  is read \n";

    while(!infile.eof()) {
	        getline(infile,STRING);
            samplenames[i] = STRING ;
            i++;
    }

    if (STRING == "") n_sample = i - 1; else n_sample = i; // make robust to (not) empty final string


    infile.close();
}





void read_mean_sd(const char * filename) {

    string STRING, subst;
	ifstream infile;
	size_t pos, oldpos;

	infile.open (filename);

    if (!(infile).is_open()) { cout << "file named " << filename << "  is not open \n"; exit(-1);}
      else cout << "file named " << filename << "  is read \n";

	getline(infile,STRING); // Skipping the header

    while(!infile.eof()) {

        getline(infile,STRING);
        oldpos = STRING.find(',');
        pos=STRING.find(',',oldpos+1);
        subst = STRING.substr(oldpos + 1,pos-oldpos-1);
        mean_vector[start_coord] = atof(subst.c_str());

        oldpos = pos + 1;
        pos=STRING.find(',',oldpos);
        subst = STRING.substr(oldpos,pos-oldpos);
        sd_vector[start_coord] = atof(subst.c_str());
        start_coord++;
    }

    if (STRING=="") start_coord = start_coord-1;  // make robust to (not) empty final string

}


void sizeMatrix(matrix_t & m , int r, int c)
{
  m.clear();
  m.resize(r);
  for (int i=0; i<r; i++)
    m[i].resize(c,0);
}


